@echo off
REM 2020.11.11 BZ
REM Script pentru copierea unui fisier binar
REM
REM Mod de executare:
REM SALC.BAT HSALAR.EXE HSALAR79.EXE
REM
REM Parametru 1: fisierul sursa, ex.HSALAR.EXE
REM Parametru 2: fisierul destinatie, ex: HSALAR79.EXE

REM Testeaza daca parametrii este setata:
SET /A ARGS_COUNT=0    
FOR %%A in (%*) DO SET /A ARGS_COUNT+=1    

REM sunt 2 parametri necesari
if %ARGS_COUNT% LSS 2 (
    ECHO Eroare parametri!
    GOTO END
)

SET binar=%1
SET newFile=%2
REM Nr. secunde pentru incercare stergere fisier.
SET deletTimeOut=5

REM Testeaza daca fisierul sursa exista...
if exist %binar% (
    echo Fisierul %binar% exista!
) else (
    echo *** Fisierul %binar% nu exista!
    GOTO END
)

REM Testeaza daca fisierul destinatie exista
REM Daca da: stergere
if exist %newFile% (
    REM Incerc sa sterger fisierul in ciclu
    for /L %%a in (1,1,%deletTimeOut%) Do (
        DEL /F /Q %newFile% > nul
        if exist %newFile% ( 
            ECHO Incerc sa sterg fisier %newFile% ...
            timeout /t 1 /nobreak >nul
        ) else (
            Echo Fisierul anterior %newFile% a fost sters cu succes
            GOTO Copiere
        )
    ) 
    ECHO Fisierul anterior %newFile% nu poate fi sters!
    GOTO END
) else (
    GOTO Copiere
)

:Copiere

ECHO Copieaza %binar% la %newFile%

REM Copieaza fisier.
REM copy /b %binar% %newFile% 
SET TEMP_FOLDER=%CD%\%RANDOM%
robocopy %CD% %TEMP_FOLDER% %binar% > nul
cd %TEMP_FOLDER%
move %binar% %CD%\..\%newFile%      > nul
cd ..\
rmdir /s /q %TEMP_FOLDER%

if exist %newFile% (
    ECHO Fisierul %newFile% a fost copiat
) else (
    ECHO *** Eroare la copiere fisier %newFile%
    GOTO END
)
:END
ECHO Terminat, tastati orice pentru continuare ...
pause > NUL 
exit